﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Advancer : MonoBehaviour {

	ChuckInstance myChuck;
	Chuck.FloatCallback myGetPosCallback;

	float myPos;

	// Use this for initialization
	void Start () {
		myChuck = GetComponent<ChuckInstance>();
		myGetPosCallback = Chuck.CreateGetFloatCallback( GetPosCallback );
		myPos = 0;

		myChuck.RunCode(@"
			external float timeStep;
			external float pos;

			fun void updatePos() {
				timeStep::second => dur currentTimeStep;
				currentTimeStep / 1000 => dur deltaTime;
				now => time startTime;
				
				pos => float originalPos;
								
				while( now < startTime + currentTimeStep )
				{
					deltaTime / currentTimeStep +=> pos;
					deltaTime => now;
				}
			}	
			

			fun void playNote() {
				SinOsc foo => dac;
				0.2::second => now;
				foo =< dac;
			}

			while( true )
			{
				spork ~ playNote();
				spork ~ updatePos();
				timeStep::second => now;
			}
		");
	}
	
	// Update is called once per frame
	void Update () {
		float newTime = Mathf.Clamp( Input.mousePosition.x, 250, 1000 ) / 1000.0f;

		myChuck.SetFloat( "timeStep",  newTime );
		myChuck.GetFloat( "pos", myGetPosCallback );

		transform.position = new Vector3( myPos % 4, 0, 0 );
	}

	void GetPosCallback( System.Double pos )
	{
		myPos = (float) pos;
	}
}
